Require Import HoTT.
Hint Rewrite @inv_pp : paths.

Goal forall `{Funext} A (sA : option A -> A),
  Contr {
    f : nat -> A &
    (f 0 = sA None) *
    (forall n, f n.+1 = sA (Some (f n)))}.
Proof.
  intros.
  set (f := nat_rect _ (sA None) (fun n r => sA (Some r))).
  set (p1 := idpath : f 0 = sA None).
  set (p2 :=
    nat_rect
      (fun n => f n.+1 = sA (Some (f n)))
      (idpath : f 1 = sA (Some (f 0)))
      (fun n r => idpath)).
  exists (f; (p1, p2)).
  intros [f' [p1' p2'] ].
  set (s' :=
    nat_rect
      (fun n => f n = f' n)
      (p1 @ p1'^)
      (fun n IHn => ap (sA o @Some _) IHn @ (p2' n)^)
  ).
  set (s := apD10^-1 s').
  erapply path_sigma; simpl.
  - exact s.
  - transitivity (transport (fun f => f 0 = sA None) s p1,
      transport (fun f => forall n, f n.+1 = sA (Some (f n))) s p2). {
      by path_induction.
    }
    f_ap.
    + transitivity ((apD10 s 0)^ @ p1). {
        by path_induction.
      }
      unfold s.
      rewrite eisretr.
      simpl.
      by autorewrite with paths.
    + by_extensionality n.
      transitivity (transport
        (fun f0 : nat -> A => f0 n.+1 = sA (Some (f0 n)))
        s
        (p2 n)). {
        by path_induction.
      }
      transitivity (
        (apD10 s n.+1)^ @
        p2 n @
        ap (sA o @Some _) (apD10 s n)). {
        rewrite transport_paths_FlFr.
        f_ap.
        by path_induction.
      }
      unfold s.
      rewrite eisretr.
      simpl.
      destruct n;
        by autorewrite with paths.
Qed.
